
#include <handler/handler.h>

template <int i,typename T>
inline cell convertToAMXX(T object){}

template <>
inline cell convertToAMXX<1>(void* v)
{
	return (cell) v;
}

template <int i,typename T>
inline T convertFromAMXX(cell v){}

template <>
inline void* convertFromAMXX<1>(cell v)
{
	return (void*) v;
}

// This line is to make sure we are hooking the same way were are calling
Handler::GateType test = &Handler::Gate;

#ifdef __linux__
	int Handler::Gate(void* arg1)
#else
	int _fastcall Handler::Gate(void* arg1)
#endif
	{
		FunctionForHandler* function = Rage->init();

		Handler* handler = static_cast<Handler*>(function->get_handler());
	
		CVector<int>* plugin_hooks = function->get_plugin_hooks();
		CVector<void*>* module_hooks =  function->get_module_hooks();

		handler->init(arg1);

		RageHookReturn hook_ret = RageHookIgnored;
	
		handler->call_module_hooks(module_hooks[RageHookPre],hook_ret);

		handler->call_plugin_hooks(plugin_hooks[RageHookPre],hook_ret,RageHookPre);

		handler->call_original(function,hook_ret);
		
		handler->call_module_hooks(module_hooks[RageHookPost],hook_ret);
	
		handler->call_plugin_hooks(plugin_hooks[RageHookPost],hook_ret,RageHookPost);

		int ret = handler->end();

		Rage->end();

		return ret;
	}

void Handler::init(void* arg1)
{
	this->Data.Arguments.arg1 = arg1;

	convertArgumentsToAMXX();
}

void Handler::convertArgumentsToAMXX()
{
	this->Data.ArgumentsAMXX.arg1 = convertToAMXX<1>(this->Data.Arguments.arg1);
}

void Handler::call_original(FunctionForHandler* function,RageHookReturn& ret)
{
	if(ret == RageHookSupercede)
		return;

	GateType original_address = (GateType) function->get_original_address();
	
	function->pre_call();
	
#ifdef __linux__
	int original_ret = original_address(
		Data.Arguments.arg1
	);
#else
	int original_ret = original_address(
		Data.Arguments.arg1
	);
#endif
		
	function->post_call();

	if(ret != RageHookOverride)
	{
		Data.Return = original_ret;
	}
}

int Handler::end()
{
	return Data.Return;
}

void Handler::call_plugin_hooks(CVector<int>& hooks,RageHookReturn& ret, RageHookPhase rage_hook_phase)
{
	if(ret != RageHookIgnored)
		return;

	if(!hooks.size())
		return;

	switch(rage_hook_phase)
	{
		case RageHookPre :
		{
			this->rage_get_return_current = &Handler::rage_get_return_pre;
			break;
		}
		case RageHookPost :
		{
			this->rage_get_return_current = &Handler::rage_get_return_normal;
			break;
		}
	}

	this->rage_set_return_current = &Handler::rage_set_return_normal;
	this->rage_set_param_current = &Handler::rage_set_param_normal;
		
	for(unsigned int i=0;i<hooks.size();i++)
	{
		ret = (RageHookReturn) MF_ExecuteForward(hooks[i],Data.ArgumentsAMXX.arg1,Data);

		if(ret != RageHookIgnored)
		{
			break;
		}
	}

	this->disable_amxx_hook_functions();
}

void Handler::call_module_hooks(CVector<void*>& hooks,RageHookReturn& ret)
{
	if(ret != RageHookIgnored)
		return;

	if(!hooks.size())
		return;

	for(unsigned int i=0;i<hooks.size();i++)
	{
		ModuleHookType module_hook = (ModuleHookType) hooks[i];

		ret = module_hook(
			Data.Arguments.arg1,
			Data.Return
		);

		convertArgumentsToAMXX();

		if(ret != RageHookIgnored)
			return;
	}
}

int Handler::create_plugin_hook(AMX* amx,const char* function_name)
{
	return g_fn_RegisterSPForwardByName(amx,function_name,FP_CELL,FP_DONE);
}

cell Handler::rage_call(FunctionForHandler* function,AMX* amx,cell* params)
{
	unsigned int n_params = params[0] / sizeof(cell);

	if(n_params != 5)
	{
		MF_LogError(amx, AMX_ERR_NATIVE, "rage_call invalid parameter count");
		return 0;
	}

	GateType managed_address = (GateType) function->get_managed_address();
			
	void* arg1 = convertFromAMXX<1,void*>(*MF_GetAmxAddr(amx,params[1]));

	#ifdef __linux__
		int ret = managed_address(arg1);
	#else
		int ret = managed_address(arg1);
	#endif

	return ret;
}

cell Handler::rage_set_param_invalid_point(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "Can't call rage set param at this point");
	return 0;
}

cell Handler::rage_set_param_normal(AMX* amx,cell* params)
{
	unsigned int n_params = params[0] / sizeof(cell);

	if(n_params != 2)
	{
		MF_LogError(amx, AMX_ERR_NATIVE, "rage_set_param Invalid parameter count");
		return 0;
	}

	switch(params[1])
	{
		case 1:
		{
			Data.ArgumentsAMXX.arg1 = *MF_GetAmxAddr(amx,params[2]);
			Data.Arguments.arg1 = convertFromAMXX<1,void*>(Data.ArgumentsAMXX.arg1);
					
			break;
		}
		default:
		{
			MF_LogError(amx, AMX_ERR_NATIVE, "Parameter out of range");
		}
	};

	return 1;
}

cell Handler::rage_set_param(AMX* amx,cell* params)
{
	return (this->*rage_set_param_current)(amx,params);
}


cell Handler::rage_set_return_invalid_point(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "Can't call rage set return at this point");
	return 0;
}

cell Handler::rage_set_return_normal(AMX* amx,cell* params)
{
	unsigned int n_params = params[0] / sizeof(cell);

	if(n_params != 1)
	{
		MF_LogError(amx, AMX_ERR_NATIVE, "rage_set_return invalid parameter count");
		return 0;
	}

	Data.Return = *MF_GetAmxAddr(amx,params[1]);

	return 1;
}

cell Handler::rage_set_return(AMX* amx,cell* params)
{
	return (this->*rage_set_return_current)(amx,params);
}

cell Handler::rage_get_return_invalid_point(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "Can't call rage get return at this point");
	return 0;
}

cell Handler::rage_get_return_pre(AMX* amx,cell* params)
{
	MF_LogError(amx, AMX_ERR_NATIVE, "Can't call rage get return in pre hooks");
	return 0;
}

cell Handler::rage_get_return_normal(AMX* amx,cell* params)
{
	unsigned int n_params = params[0] / sizeof(cell);

	if(n_params != 0)
	{
		MF_LogError(amx, AMX_ERR_NATIVE, "rage_get_return invalid parameter count");
		return 0;
	}

	return Data.Return;
}

cell Handler::rage_get_return(AMX* amx,cell* params)
{
	return (this->*rage_get_return_current)(amx,params);
}

Handler::Handler(char* name) : name(name)
{
	disable_amxx_hook_functions();
}

void Handler::disable_amxx_hook_functions()
{
	this->rage_set_param_current = &Handler::rage_set_param_invalid_point;
}

char* Handler::get_name()
{
	return this->name;
}

void* Handler::get_gate_address()
{
	return (void*)&Gate;
}

int Handler::AMXX_Detach()
{
#ifdef FN_AMXX_DETACH
	FN_AMXX_DETACH();
#endif // FN_AMXX_DETACH

	return AMXX_OK;
}

int Handler::AMXX_PluginsLoaded()
{
#ifdef FN_AMXX_PLUGINSLOADED
	FN_AMXX_PLUGINSLOADED();
#endif // FN_AMXX_PLUGINSLOADED
	return AMXX_OK;
}

void Handler::AMXX_PluginsUnloaded()
{
#ifdef FN_AMXX_PLUGINSUNLOADED
	FN_AMXX_PLUGINSUNLOADED();
#endif // FN_AMXX_PLUGINSUNLOADED
}

void Handler::AMXX_PluginsUnloading()
{
#ifdef FN_AMXX_PLUGINSUNLOADING
	FN_AMXX_PLUGINSUNLOADING();
#endif // FN_AMXX_PLUGINSUNLOADING
}
