
#ifndef _INCLUDE_HANDLER__H_
#define _INCLUDE_HANDLER__H_

#include <handler/handler_for_rage.h>
#include <rage/rage_for_handler.h>
#include <rage/rage_hook_return.h>
#include <rage/rage_hook_phase.h>
#include <CVector.h>

typedef int DUMMY;
const int DUMMY_VAL = 0;

extern RageForHandler* Rage;

class Handler : public HandlerForRage
{
	private:
		
		char* name;
		
		struct ArgumentsType
		{
			void* arg1;
		};

		struct ArgumentsAMXXType
		{
			cell arg1;
		};

		struct 
		{
			ArgumentsType Arguments;
			ArgumentsAMXXType ArgumentsAMXX;
			int Return;
			
		} Data;

		cell (Handler::*rage_set_param_current)(AMX* amx,cell* params);
		cell (Handler::*rage_get_return_current)(AMX* amx,cell* params);
		cell (Handler::*rage_set_return_current)(AMX* amx,cell* params);

	public:
		
		Handler(char* name);

		char* get_name();
		void* get_gate_address();

		typedef RageHookReturn (*ModuleHookType)(void*&,int& ret);

#ifdef __linux__
		static int Gate(void*);
		typedef int (*GateType)(void*);
#else
		static int _fastcall Gate(void*);
		typedef int (_fastcall *GateType)(void*);
#endif
		
		void init(void*);
		void convertArgumentsToAMXX();
		void call_original(FunctionForHandler* function,RageHookReturn& ret);
		int end();

		void call_plugin_hooks(CVector<int>& hooks,RageHookReturn& ret, RageHookPhase rage_hook_phase);
		void call_module_hooks(CVector<void*>& hooks,RageHookReturn& ret);
		int create_plugin_hook(AMX* amx,const char* function_name);
		cell rage_call(FunctionForHandler* function,AMX* amx,cell* params);
		cell rage_set_param_invalid_point(AMX* amx,cell* params);
		cell rage_set_param_normal(AMX* amx,cell* params);
		cell rage_set_param(AMX* amx,cell* params);
		cell rage_set_return_invalid_point(AMX* amx,cell* params);
		cell rage_set_return_normal(AMX* amx,cell* params);
		cell rage_set_return(AMX* amx,cell* params);
		cell rage_get_return_invalid_point(AMX* amx,cell* params);
		cell rage_get_return_pre(AMX* amx,cell* params);
		cell rage_get_return_normal(AMX* amx,cell* params);
		cell rage_get_return(AMX* amx,cell* params);
		
		void disable_amxx_hook_functions();
		
		int AMXX_Detach();
		int AMXX_PluginsLoaded();
		void AMXX_PluginsUnloaded();
		void AMXX_PluginsUnloading();
};

#endif
